#include "sys.h"
#include "debug.h"
#include "bitsetTest.h"

void bitsetTest::testInequality(void)
{
  CPPUNIT_ASSERT( !(b7v3 != b7v3) );
  CPPUNIT_ASSERT( !(b7v3 != b32v3) );
  CPPUNIT_ASSERT( !(b32v3 != b7v3) );
  CPPUNIT_ASSERT( b7v3 != b32v32 );
  CPPUNIT_ASSERT( b32v32 != b7v3 );
  CPPUNIT_ASSERT( b7v3 != b39v32 );
  CPPUNIT_ASSERT( b39v32 != b7v3 );
  CPPUNIT_ASSERT( b7v3 != b64v64 );
  CPPUNIT_ASSERT( b64v64 != b7v3 );
  CPPUNIT_ASSERT( b7v3 != b64v63 );
  CPPUNIT_ASSERT( b64v63 != b7v3 );
  CPPUNIT_ASSERT( b7v3 != b65v65 );
  CPPUNIT_ASSERT( b65v65 != b7v3 );
  CPPUNIT_ASSERT( b7v3 != b195v195 );
  CPPUNIT_ASSERT( b195v195 != b7v3 );
  CPPUNIT_ASSERT( b7v3 != b205v195 );
  CPPUNIT_ASSERT( b205v195 != b7v3 );
  CPPUNIT_ASSERT( b7v3 != b205v205 );
  CPPUNIT_ASSERT( b205v205 != b7v3 );

  CPPUNIT_ASSERT( !(b32v3 != b32v3) );
  CPPUNIT_ASSERT( b32v3 != b32v32 );
  CPPUNIT_ASSERT( b32v32 != b32v3 );
  CPPUNIT_ASSERT( b32v3 != b39v32 );
  CPPUNIT_ASSERT( b39v32 != b32v3 );
  CPPUNIT_ASSERT( b32v3 != b64v64 );
  CPPUNIT_ASSERT( b64v64 != b32v3 );
  CPPUNIT_ASSERT( b32v3 != b64v63 );
  CPPUNIT_ASSERT( b64v63 != b32v3 );
  CPPUNIT_ASSERT( b32v3 != b65v65 );
  CPPUNIT_ASSERT( b65v65 != b32v3 );
  CPPUNIT_ASSERT( b32v3 != b195v195 );
  CPPUNIT_ASSERT( b195v195 != b32v3 );
  CPPUNIT_ASSERT( b32v3 != b205v195 );
  CPPUNIT_ASSERT( b205v195 != b32v3 );
  CPPUNIT_ASSERT( b32v3 != b205v205 );
  CPPUNIT_ASSERT( b205v205 != b32v3 );

  CPPUNIT_ASSERT( !(b32v32 != b32v32) );
  CPPUNIT_ASSERT( !(b32v32 != b39v32) );
  CPPUNIT_ASSERT( !(b39v32 != b32v32) );
  CPPUNIT_ASSERT( b32v32 != b64v64 );
  CPPUNIT_ASSERT( b64v64 != b32v32 );
  CPPUNIT_ASSERT( b32v32 != b64v63 );
  CPPUNIT_ASSERT( b64v63 != b32v32 );
  CPPUNIT_ASSERT( b32v32 != b65v65 );
  CPPUNIT_ASSERT( b65v65 != b32v32 );
  CPPUNIT_ASSERT( b32v32 != b195v195 );
  CPPUNIT_ASSERT( b195v195 != b32v32 );
  CPPUNIT_ASSERT( b32v32 != b205v195 );
  CPPUNIT_ASSERT( b205v195 != b32v32 );
  CPPUNIT_ASSERT( b32v32 != b205v205 );
  CPPUNIT_ASSERT( b205v205 != b32v32 );

  CPPUNIT_ASSERT( !(b39v32 != b39v32) );
  CPPUNIT_ASSERT( b39v32 != b64v64 );
  CPPUNIT_ASSERT( b64v64 != b39v32 );
  CPPUNIT_ASSERT( b39v32 != b64v63 );
  CPPUNIT_ASSERT( b64v63 != b39v32 );
  CPPUNIT_ASSERT( b39v32 != b65v65 );
  CPPUNIT_ASSERT( b65v65 != b39v32 );
  CPPUNIT_ASSERT( b39v32 != b195v195 );
  CPPUNIT_ASSERT( b195v195 != b39v32 );
  CPPUNIT_ASSERT( b39v32 != b205v195 );
  CPPUNIT_ASSERT( b205v195 != b39v32 );
  CPPUNIT_ASSERT( b39v32 != b205v205 );
  CPPUNIT_ASSERT( b205v205 != b39v32 );

  CPPUNIT_ASSERT( !(b64v64 != b64v64) );
  CPPUNIT_ASSERT( b64v64 != b64v63 );
  CPPUNIT_ASSERT( b64v63 != b64v64 );
  CPPUNIT_ASSERT( b64v64 != b65v65 );
  CPPUNIT_ASSERT( b65v65 != b64v64 );
  CPPUNIT_ASSERT( b64v64 != b195v195 );
  CPPUNIT_ASSERT( b195v195 != b64v64 );
  CPPUNIT_ASSERT( b64v64 != b205v195 );
  CPPUNIT_ASSERT( b205v195 != b64v64 );
  CPPUNIT_ASSERT( b64v64 != b205v205 );
  CPPUNIT_ASSERT( b205v205 != b64v64 );

  CPPUNIT_ASSERT( !(b64v63 != b64v63) );
  CPPUNIT_ASSERT( b64v63 != b65v65 );
  CPPUNIT_ASSERT( b65v65 != b64v63 );
  CPPUNIT_ASSERT( b64v63 != b195v195 );
  CPPUNIT_ASSERT( b195v195 != b64v63 );
  CPPUNIT_ASSERT( b64v63 != b205v195 );
  CPPUNIT_ASSERT( b205v195 != b64v63 );
  CPPUNIT_ASSERT( b64v63 != b205v205 );
  CPPUNIT_ASSERT( b205v205 != b64v63 );

  CPPUNIT_ASSERT( !(b65v65 != b65v65) );
  CPPUNIT_ASSERT( b65v65 != b195v195 );
  CPPUNIT_ASSERT( b195v195 != b65v65 );
  CPPUNIT_ASSERT( b65v65 != b205v195 );
  CPPUNIT_ASSERT( b205v195 != b65v65 );
  CPPUNIT_ASSERT( b65v65 != b205v205 );
  CPPUNIT_ASSERT( b205v205 != b65v65 );

  CPPUNIT_ASSERT( !(b195v195 != b195v195) );
  CPPUNIT_ASSERT( !(b195v195 != b205v195) );
  CPPUNIT_ASSERT( !(b205v195 != b195v195) );
  CPPUNIT_ASSERT( b195v195 != b205v205 );
  CPPUNIT_ASSERT( b205v205 != b195v195 );

  CPPUNIT_ASSERT( !(b205v195 != b205v195) );
  CPPUNIT_ASSERT( b205v195 != b205v205 );
  CPPUNIT_ASSERT( b205v205 != b205v195 );

  CPPUNIT_ASSERT( !(b205v205 != b205v205) );
}
