#include "sys.h"
#include "debug.h"
#include <iostream>
#include <string>
#include <libecc/sha.h>

void print_hash(std::string const& message)
{
  using libecc::bitset_digit_t;
  size_t bits = 8 * message.size();
  size_t digits = (message.size() + sizeof(bitset_digit_t) - 1) / sizeof(bitset_digit_t);
  bitset_digit_t* buf = new bitset_digit_t[digits];
  int shift = 0;
  int digit = -1;
  for (std::string::const_reverse_iterator iter = message.rbegin();
       iter != message.rend();
       ++iter)
  {
    if (shift == 0)
      buf[++digit] = *iter;
    else
      buf[digit] |= *iter << 8 * shift;
    shift = (shift + 1) % sizeof(bitset_digit_t);
  }
  libecc::sha sha;
  sha.process_msg(buf, bits);
  delete [] buf;
  std::cout << sha.digest() << '\n';
}

int main(void)
{
  std::string s = "abc";
  print_hash(s);

  return 0;
}
